%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%           
%
% File:         SYSCONST
% Description:  CRAY (COS)  PSL constants needed in the compiler
% Author:       W. Neun , ZIB Berlin
% Created:      10-Jan-86
% Mode:         Lisp
% Package:
% Status:       Experimental (Do Not Distribute)
%
% Copyright (c) 1987, Konrad Zuse Zentrum Berlin, all rights reserved
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%
% Revisions
% 26-Oct-1988    W. Neun ,ZIB Berlin
%  Changed fasl magics because old PSL's may NOT load new objects
% 30-Sep-1988    W. Neun ,ZIB Berlin
%  Changed maxsymbols to 16000 (Was too small for reduce)
 
   (compiletime (load if-system))  % propagate  the  actual system
 
   (imports '(tags))
 
   (fluid '(system_list*))
 
  (if_system Cray-2
   (setq system_list* '(CRAY-2 CRAY CRAY-UNICOS UNICOS Unix))
   (if_system Y-MP
    (setq system_list* '(Y-MP  CRAY CRAY-UNICOS UNICOS Unix))
    (if_system Cray1
     (setq system_list* '(Cray1 CRAY CRAY-COS))
     (if_system UNICOS
     (setq system_list* '(X-MP  CRAY CRAY-UNICOS UNICOS Unix))
     (setq system_list* '(X-MP  CRAY CRAY-COS))))))
                                     %cant use COS alone, COSINE!!
 
   (define-constant faslin-magic                  199)
   (define-constant faslout-magic                 199)
 
   (define-constant tagstartingbit                  0)
   (define-constant tagbitlength                    5)
   (define-constant infstartingbit                  27)
   (define-constant infbitlength                    37)
   (define-constant GCStartingBit                   5)
   (define-constant GCBitLength                     22)
   (define-constant addressingunitsperitem          1)
   (define-constant charactersperword               8)
   (define-constant bitsperword                     64)
   (define-constant bitsperword2                    16)
   (define-constant stackdirection                  1)
   (define-constant addressingunitsperfunctioncell  1)
   (define-constant nontagpart                      59)
 
   (define-constant &LinkShift&                     16)
   (define-constant &LinkShiftBits&                 4)
   (define-constant &LinkShiftPos&                  60)
 
   (define-constant maxrealregs                     5)
   (define-constant maxargs                         15)
 
   (define-constant initial-stacksize               5000)
   (define-constant initial-bndstksize              500)
   (define-constant compressedbinaryradix           8)
   (define-constant maxtokensize                    512)
   (define-constant catchstacksize                  400)
   (define-constant hash-table-size                 18013)
%% (define-constant maxsymbols                      8000)
   (define-constant maxsymbols                      16000)
   (define-constant initial-heapsize               200000)
   (define-constant initial-bpssize                200000)
 
 %  bpssize, heapsize and stacksize bndstksize are variable now !!
 
 (fluid '(bpssize heapsize stacksize bndstksize))
 
   % At present this is the single machine-dependent character
   % (for ASCII machines).  Defined here in case cross-compilation
   % is being done.  Defined for the kernel in pv:scan-table.sl. /csp
 
   (put 'eof 'charconst (char (control z)))
