%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:           PXNK:LAP.SL
% Title:          LAP support for EVAL and APPLY  (Hacked version for testing)
% Author:         Eric Benson
% Created:        20 August 1981
% Modified:       26 Jan 1984 1040-PST (Brian Beach)
% Status:         Experimental
% Mode:           Lisp
% Package:        Kernel
%
% (c) Copyright 1983, Hewlett-Packard Company, all rights reserved.
% (c) Copyright 1981, University of Utah
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 01-Sep-88 (Julian Padget)
%  Bnd... declarations changed from fluid to global.
% 26 Jan 1984 1036-PST (Brian Beach)
%  Corrected file name in header.
% 2-Dec-83  16:00:00 (Brian Beach)
%   Translated from Rlisp to Lisp.
% Griss and Perdue, 10 January 1983
%	Modified Undefined function to make compiled calls
%	continuable
%
% may 23-1988 chris burdorf and T. Yamamoto
%   modified for sparc, got rid of vax specific code in casel, extv, 
%   autoincrement, and divl
%
% July 20,1988 T. Yamamoto: inline coding of argument distribution.
% November15 1988 W. Neun, removed move and *move (frame  ) cmacros
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(global '(bndstkptr bndstkupperbound))

(compiletime (load sys-macros))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% if this could be written in Syslisp, it would look something like this:
%
% syslsp procedure CodeApply(CodePtr, ArgList);
% begin scalar N;
%     N := 0;
%     while PairP ArgList do
%     <<  N := N + 1;
%	  ArgumentRegister[N] := car ArgList;
%	  ArgList := cdr ArgList >>;
%     (jump to address of code pointer)
% end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(compiletime (on pcmac))
(lap '((*entry codeapply expr 2)
       %
       % CodeApply(CodePointer, ArgList)
       %
       % (reg 1) is code pointer
       % (reg 2) is arg list
       %
       (*alloc 0)
       (stm (reg r14) (reg r3) (displacement (reg st) 12))
       (*field (reg 3) (reg 1) 5 27)	% (reg t1) <- entry point.
       (*move (reg 3) (reg r3))	% (reg t2) <- arglist

       (*move (reg 2) (reg r2))

       (*jumpeq (label CONTINUE) (reg r2) (reg nil))	% 0 argument

       (*move (car (reg r2)) (reg 1))
       (*move (cdr (reg r2)) (reg r2))
       (*jumpeq (label CONTINUE) (reg r2) (reg nil))

       (*move (car (reg r2)) (reg 2))
       (*move (cdr (reg r2)) (reg r2))
       (*jumpeq (label CONTINUE) (reg r2) (reg nil))

       (*move (car (reg r2)) (reg 3))
       (*move (cdr (reg r2)) (reg r2))
       (*jumpeq (label CONTINUE) (reg r2) (reg nil))

       (*move (car (reg r2)) (reg 4))
       (*move (cdr (reg r2)) (reg r2))
       (*jumpeq (label CONTINUE) (reg r2) (reg nil))

       (*move (car (reg r2)) (reg 5))
       (*move (cdr (reg r2)) (reg r2))
       (*jumpeq (label CONTINUE) (reg r2) (reg nil))

       (*move (car (reg r2)) (reg r0))
       (*move (reg r0) (reg 6))
       (*move (cdr (reg r2)) (reg r2))
       (*jumpeq (label CONTINUE) (reg r2) (reg nil))

       (*move (car (reg r2)) (reg r0))
       (*move (reg r0) (reg 7))
       (*move (cdr (reg r2)) (reg r2))
       (*jumpeq (label CONTINUE) (reg r2) (reg nil))

       (*move (car (reg r2)) (reg r0))
       (*move (reg r0) (reg 8))
       (*move (cdr (reg r2)) (reg r2))
       (*jumpeq (label CONTINUE) (reg r2) (reg nil))

       (*move (car (reg r2)) (reg r0))
       (*move (reg r0) (reg 9))
       (*move (cdr (reg r2)) (reg r2))
       (*jumpeq (label CONTINUE) (reg r2) (reg nil))

       (*move (car (reg r2)) (reg r0))
       (*move (reg r0) (reg 10))
       (*move (cdr (reg r2)) (reg r2))
       (*jumpeq (label CONTINUE) (reg r2) (reg nil))

       (*move (car (reg r2)) (reg r0))
       (*move (reg r0) (reg 11))
       (*move (cdr (reg r2)) (reg r2))
       (*jumpeq (label CONTINUE) (reg r2) (reg nil))

       (*move (car (reg r2)) (reg r0))
       (*move (reg r0) (reg 12))
       (*move (cdr (reg r2)) (reg r2))
       (*jumpeq (label CONTINUE) (reg r2) (reg nil))

       (*move (car (reg r2)) (reg r0))
       (*move (reg r0) (reg 13))
       (*move (cdr (reg r2)) (reg r2))
       (*jumpeq (label CONTINUE) (reg r2) (reg nil))

       (*move (car (reg r2)) (reg r0))
       (*move (reg r0) (reg 14))
       (*move (cdr (reg r2)) (reg r2))
       (*jumpeq (label CONTINUE) (reg r2) (reg nil))

       (*move (car (reg r2)) (reg r0))
       (*move (reg r0) (reg 15))
       (*move (cdr (reg r2)) (reg r2))
       (*jumpeq (label CONTINUE) (reg r2) (reg nil))

       (*move (quote "Too many arguments to function") (reg 1))
       (lm (reg r14) (reg r2) (displacement (reg st) 12))
       (*linke 0 stderror expr 5)
       
CONTINUE
       (*dealloc 0)
       (*move (reg r3) (reg t1))
       (lm (reg r14) (reg r3) (displacement (reg st) 12))
       (*move (reg t1) (reg r15))
       (br (reg r15))))
(compiletime (off pcmac))
       
(de codeevalapply (codeptr arglist)
  (codeapply codeptr (evlis arglist)))

(de bindeval (formals args)
  (bindevalaux formals args 0))

(de bindevalaux (formals args n)
  (let (f
        a)
       (cond ((pairp formals) (if (pairp args)
                (progn (setq f (first formals))
                       (setq a (eval (first args)))
                       (setq n
                        (bindevalaux (rest formals) (rest args) (iadd1 n)))
                       (if (weq n -1)
                         -1
                         (progn (lbind1 f a)
                                n)))
                -1))
             ((pairp args) -1)
             (t n))))


(lap '((*entry undefinedfunctionaux expr 0)
       %
       % (reg t2) <- offset of symfnc table
       %
       (*alloc 16)
       (*move (reg t2) (frame 1)) 
       (*move (reg 1)(frame 2))
                                % Save all the regs (including fakes) (args)
       (*move (reg 2)(frame 3))
       (*move (reg 3)(frame 4))
       (*move (reg 4)(frame 5))
       (*move (reg 5)(frame 6))
       (*move (reg 6)(frame 7))
       (*move (reg 7)(frame 8))
       (*move (reg 8)(frame 9))
       (*move (reg 9)(frame 10))
       (*move (reg 10)(frame 11))
       (*move (reg 11)(frame 12))
       (*move (reg 12)(frame 13))
       (*move (reg 13)(frame 14))
       (*move (reg 14)(frame 15))
       (*move (reg 15)(frame 16))

       (*move (frame 1) (reg 2))
       (*mkitem (reg 2) (wconst id-tag))
       (*move (reg 2) (frame 1))
       (*move '"Undefined function %r called from compiled code" (reg 1))
       (*call bldmsg)
       (*move (reg 1) (reg 2))
       (*move (wconst 0) (reg 1))
       (*move (reg nil) (reg 3))
       (*call continuableerror)

       (*move (frame 16 ) (reg 15))
       (*move (frame 15 ) (reg 14))
       (*move (frame 14 ) (reg 13))
       (*move (frame 13 ) (reg 12))
       (*move (frame 12 ) (reg 11))
       (*move (frame 11 ) (reg 10))
       (*move (frame 10 ) (reg 9))
       (*move (frame 9 ) (reg 8))
       (*move (frame 8 ) (reg 7))
       (*move (frame 7 ) (reg 6))
       (*move (frame 6 ) (reg 5))
       (*move (frame 5 ) (reg 4))
       (*move (frame 4 ) (reg 3))
       (*move (frame 3 ) (reg 2))
       (*move (frame 2 ) (reg 1))
       (*move (frame 1) (reg t1))
       (*linke 16 fastapply expr 0)))

%
% This is pretty gross, but it is essentially the same as LambdaApply, taking
% values from the argument registers instead of a list.
% if this could be written in Syslisp, it would look something like this:
%
% syslsp procedure CompiledCallingInterpreted IDOfFunction;
% begin scalar LForm, LArgs, N, Result;
%     LForm := get(IDOfFunction, '!*LambdaLink);
%     LArgs := cadr LForm;
%     LForm := cddr LForm;
%     N := 1;
%     while PairP LArgs do
%     <<  LBind1(car LArgs, ArgumentRegister[N];
%         LArgs := cdr LArgs;
%         N := N + 1 >>;
%     Result := EvProgN LForm;
%     UnBindN(N - 1);
%     return Result;
% end;

(lap '((*entry fastapply expr 0)
 
       % Apply with arguments loaded
       %
       % Cadded with arguments in the registers and functional form in t1.
 
       (using "*" (reg r15))
       (stm (reg r14) (reg r2) (displacement (reg st) 12))
       (*field (reg r0)                    % Tag of function into r0
               (reg t1)
               (wconst tagstartingbit)
               (wconst tagbitlength))
       (*field (reg t1)                    % Inf of function into T1
               (reg t1) 
               (wconst infstartingbit)
               (wconst infbitlength))
 
       (*jumpnoteq (label notanid) (reg r0) (wconst id-tag))
 
       % ID: Link through function cell
       (*move (reg t1) (reg r2))
       (*move (reg r2) (reg r0))
       (*wshift (reg r2) 2) % multiply by addressingunitsperfunctioncell
       (*wplus2  (reg r2) (fluid symfnc))
       (*move (reg r2) (reg r15))
       (lm (reg r1) (reg r2) (displacement (reg st) 24))
       (*move (displacement (reg r15) 0) (reg r15))
       (lr (reg t2) (reg r0))
       (BR (reg r15))
 
NOTANID (*jumpnoteq (label notacodepointer) (reg r0) (wconst code-tag))
 
       % Code pointer: jump direct
	(lm (reg r14) (reg r2) (displacement (reg st) 12))
	(*move (reg t1) (reg r15))
        (BR (reg r15))

NOTACODEPOINTER
       (*jumpnoteq (label illegalfunctionalform) (reg r0) (wconst pair-tag))
 
       % Pair: make sure it's a lambda, then call FASTLAMBDAPPLY.
 
       (*move (memory (reg t1) (wconst 0)) (reg t2)) % CAR of the inf field.
       (*move (quote lambda) (reg r2))
       (*jumpnoteq (label illegalfunctionalform) (reg t2) (reg r2))
 
       (lm (reg r14) (reg r2) (displacement (reg st) 12))
       (*jcall fastlambdaapply)         % (reg t1) <- lambda function
 
ILLEGALFUNCTIONALFORM
       (*move '"Illegal functional form in Apply" (reg 1))
       (*move (reg t1) (reg 2))
       (*call list2)
       (lm (reg r14) (reg r2) (displacement (reg st) 12))
       (*jcall stderror)
))

(lap '( (*entry fastlambdaapply expr 0)		   % called from FastApply
        (*alloc 6)
        (*move  (reg t1) (frame 2))

        (*move (cdr (frame 2)) (frame 2))     % get cdr of lambda form
        (*move (cdr (frame 2)) (frame 1))     % save cddr in (reg t1)
        (*move (car (frame 2)) (frame 2))     % cadr of lambda form == arg list
					   % in (reg t2)
        (*move (fluid bndstkupperbound) (frame 3))
					   % binding stack limit.
        (*move (fluid bndstkptr) (frame 4))  % binding stack pointer in (reg t4)
        (*move (fluid bndstkptr) (frame 6))  % plus a copy for restoring
%
%	The first argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 1) (memory (frame 5) (wconst 0)))
%
%	The second argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 2) (memory (frame 5) (wconst 0)))
%
%	The third argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 3) (memory (frame 5) (wconst 0)))
%
%	The fourth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 4) (memory (frame 5) (wconst 0)))
%
%	The fifth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 5) (memory (frame 5) (wconst 0)))

%	The sixth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 6) (memory (frame 5) (wconst 0)))
%
%	The seventh argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 7) (memory (frame 5) (wconst 0)))
%
%	The eighth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 8) (memory (frame 5) (wconst 0)))
%
%	The nineth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 9) (memory (frame 5) (wconst 0)))
%
%	The tenth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 10) (memory (frame 5) (wconst 0)))
%
%	The eleventh argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 11) (memory (frame 5) (wconst 0)))
%
%	The twelveth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 12) (memory (frame 5) (wconst 0)))
%
%	The thirteenth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 13) (memory (frame 5) (wconst 0)))
%
%	The fourteenth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 14) (memory (frame 5) (wconst 0)))
%
%	The fifteenth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 15) (memory (frame 5) (wconst 0)))
%
%	The sixteenth argument
%
        (*jumpnottype (label DONEBINDINGFORMALS) (frame 2) pair-tag)
        (*wplus2 (frame 4) (wconst 8))
        (*jumpwgeq (label BINDINGOVERFLOW) (frame 4) (frame 3))
        (*move (car (frame 2)) (frame 5))
        (*move (cdr (frame 2)) (frame 2))
        (*field (frame 5) (frame 5) 5 27)	% (reg t5) <- id number
        (*move (frame 5) (memory (frame 4) (wconst -4)))
        (*wshift (frame 5) 2)
        (*wplus2 (frame 5) (fluid symval))
        (*move (memory (frame 5) (wconst 0)) (memory (frame 4) (wconst 0)))
        (*move (reg 16) (memory (frame 5) (wconst 0)))

        (*move '"Too many arguments to function" (reg 1))
        (*linke 6 stderror expr 0)

BINDINGOVERFLOW
        (*linke 6 bstackoverflow expr 0)             % then error

DONEBINDINGFORMALS
        (*move (frame 4) (fluid bndstkptr))  % store binding stack
        (*move (frame 1) (reg 1))            % get cddr of lambda form to eval
        (*call evprogn)                      % implicit progn
        (*move (reg 1) (frame 1))            % save result, get old bind stk ptr
        (*move (frame 6) (reg 1))
        (*call restoreenvironment)
        (*move (frame 1) (reg 1))
        (*exit 6)                            % and return

PROPNOTFOUND
        (*move '"*LAMBDALINK property not found for interpreted function"
               (reg 1))
        (*linke 6 stderror expr 0)
))
            
(de lambdaapply (fn args)
  % Fn is Lambda, unevaled Args
  (if (not (and (pairp fn) (weq (car fn) 'lambda)))
    (continuableerror '1104 '"Ill-formed function expression"
                      (cons fn (foreach x in args collect (mkquote x))))
    (prog (formals n result)
          (setq formals (cadr fn))
          (setq n 0)
          (while (and (pairp formals) (pairp args))
            (lbind1 (car formals) (car args))
            (setq formals (cdr formals))
            (setq args (cdr args))
            (setq n (wplus2 n 1)))
          (when (or (pairp formals) (pairp args))
            (return (continuableerror '1204 '"Argument number mismatch"
                     (cons fn (foreach x in args collect (mkquote x))))))
          (setq result (evprogn (cddr fn)))
          (when (wneq n 0)
            (unbindn n))
          (return result))))

(lap '((*entry compiledcallinginterpretedaux expr 0)
       % link for lambda
       %
       %
       (*alloc 1)
       (*wshift (reg t2) 2)
       (stm (reg 1) (reg 5) (displacement (reg st) 36))
       (*move (reg t2) (reg 1))
       (*wplus2 (reg 1) ($fluid symprp))         % Prop list address
       (*move (memory (reg 1) (wconst 0))        % Property list
              (reg 1))
LOOPFINDPROP
       (*jumpnottype (label propnotfound) (reg 1) pair-tag)
                                           % make sure prop list is a pair
       (*move (car (reg 1)) (reg 2))     % get car of prop list
       (*move (cdr (reg 1)) (reg 1))     % cdr down
       (*jumpnottype (label LOOPFINDPROP) (reg 2)  pair-tag)
       (*move (car (reg 2)) (reg 3))     % yes, look at car
       (*move (quote *lambdalink) (reg 4))
       (*jumpnoteq (label loopfindprop) (reg 3) (reg 4))
       (*move (cdr (reg 2)) (reg t1))     % yes, get lambda form
       (lm (reg 1) (reg 5) (displacement (reg st) 36))
       (*linke 1 fastlambdaapply expr 0)
PROPNOTFOUND
       (*move '"*LAMBDALINK Property not found for interpreted function"
               (reg 1))
       (*linke 1 stderror expr 0)))

