%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PNK:OTHERS-SL.SL 
% Title:        Random Standard Lisp functions 
% Author:       Eric Benson 
% Created:      20 August 1981 
% Modified:     22-Mar-84 11:41:47 (Brian Beach) 
% Status:       Experimental 
% Mode:         Lisp 
% Package:      Kernel 
% Compiletime:  
% Runtime:      
%
% (c) Copyright 1983, Hewlett-Packard Company, all rights reserved.
% (c) Copyright 1981, University of Utah
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 01-Dec-83 14:56:54 (Brian Beach)
%   Translated from Rlisp to Lisp.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% These are functions that didn't have a logical home
% Most could have been defined portably, but were not for efficiency reasons
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(off r2i)

(de fixp (u)
  % Is U an integer?
  (fixp u))

(on r2i)

(de digit (u)
  % Is U an ID whose print name is a digit?
  (and (idp u) (wgeq (setq u (idinf u)) (char !0)) (wleq u (char !9))))

(de liter (u)
  (and % Is U a single character alphabetic ID?

       (idp u)
       (or (and (wgeq (setq u (idinf u)) (char !A)) (wleq u (char !Z)))
           (and (wgeq u (char !a)) (wleq u (char !z))))))

(compiletime
  (flag '(length1) 'internalfunction))

(de length (u)
  % Length of list U
  (length1 u 0))

(de length1 (u n)
  (if (pairp u)
    (length1 (cdr u) (iadd1 n))
    n))

