%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PU:ADDR2ID.SL 
% Description:  Attempt to find out what function an address is in 
% Author:       Eric Benson, Hewlett-Packard CRC 
% Created:      18 May 1982 
% Modified:     19 Jan 1984 1428-PST (Brian Beach) 
% Status:       Experimental (Do Not Distribute) 
% Mode:         Lisp 
% Package:      Utilities 
% Compiletime:  PL:SYSLISP.B PL:USEFUL.B 
% Runtime:      
%
% (c) Copyright 1984, Hewlett-Packard Company, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 19 Jan 1984 1428-PST (Brian Beach)
%   Added standard header.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(compiletime (load useful))

(compiletime (fluid '(code-address* closest-address* closest-symbol*)))

(de code-address(symbol)
     (wand (inf (getfcodepointer symbol)) 16#ffffff))

(de code-address-to-symbol (code-address*)
  (when (fixnp code-address*) (setq code-address*(int2sys code-address*)))
  (setq code-address* (wand code-address* 16#ffffff))
  (let ((closest-symbol* 'firstkernel) 
        (closest-address* (code-address 'firstkernel)))
       (mapobl #'(lambda (symbol)
		         (when (fcodep symbol)
			       (let ((address (code-address symbol)))
				    (when (and (ileq address
						     code-address*)
					       (igreaterp address
							  closest-address*))
					  (setq closest-address*
						address)
					  (setq closest-symbol* symbol))))))
       closest-symbol*))
